searchNodes=[{"doc":"The behaviour all configured plugins should implement. Overview Writing Munin plugins is rather simple. A trivial plugin with the default Munin node setup is a script with two main behaviours: When invoked with the command line argument config , print out configuration of the plugin, such as graph setup (title, category, labels), field information and more. A full description of all options can be found at the Plugin reference documentation. When not invoked with any command line argument, print out the values for fields declared in the config command. This is the foundation from which plugins are developed. Since our node runs in the BEAM, we've taken a different approach here. Instead of being executable shell scripts, crow plugins are modules which provide two main functions: config/0 , which returns the configuration of the plugin, corresponding to the first invocation form described above. values/0 , which returns the values of the plugin, corresponding to the second invocation form described above. Instead of printing to standard output, these return a list of charlists which is then sent to the peer via TCP. An additional callback, name/0 , specifies the name of the plugin shown to Munin. This must be unique amongst all plugins configured on the node. Community plugins Plugins for the crow node can be found in the crow_plugins repository.","ref":"Crow.Plugin.html","title":"Crow.Plugin","type":"behaviour"},{"doc":"Display the configuration for this plugin. Each element in the output represents a single line in the output. Adding newlines to each line is done by the worker. For reference, see Munin plugin config command from the official documentation. Example def config do [ &#39;graph_title Total processes&#39; , &#39;graph_category BEAM&#39; , &#39;graph_vlabel processes&#39; , &#39;processes.label processes&#39; ] end","ref":"Crow.Plugin.html#c:config/0","title":"Crow.Plugin.config/0","type":"callback"},{"doc":"Return the name of the plugin displayed to peers. Example def name do &#39;my_plugin&#39; end","ref":"Crow.Plugin.html#c:name/0","title":"Crow.Plugin.name/0","type":"callback"},{"doc":"Display values for this plugin. Example def values do [ &#39;processes.value \#{ length ( :erlang . processes ( ) ) } &#39; ] end","ref":"Crow.Plugin.html#c:values/0","title":"Crow.Plugin.values/0","type":"callback"},{"doc":"","ref":"introduction.html","title":"Crow","type":"extras"},{"doc":"Crow provides a Munin node implementation that deals with speaking the Munin data exchange protocol between the master and nodes. Crow plugins are implemented as modules following the Crow.Plugin behaviour.","ref":"introduction.html#overview","title":"Crow - Overview","type":"extras"},{"doc":"Quoting the official website : Munin is a networked resource monitoring tool that can help analyze resource trends and &quot;what just happened to kill our performance?&quot; problems. It is designed to be very plug and play. Munin follows a master-node architecture. The Munin master connects to nodes which run &quot;plugins&quot; on demand. In the default Munin installation, a plugin is an executable (this can be a shell script, Python script, binary...) providing two invocation forms which print out metadata or graph values. In crow, we use modules instead of executables. See Writing plugins and the Crow.Plugin behaviour for more information. A great overview about the architecture is available at the Munin's Architecture","ref":"introduction.html#what-is-munin","title":"Crow - What is Munin?","type":"extras"},{"doc":"Crow plugins are modules implementing the Crow.Plugin behaviour. The following plugin would display a graph of the current process count running in the BEAM: defmodule MyApp.CrowPlugins.Processes do def name do &#39;beam_process_count&#39; end def config do [ &#39;graph_title Total processes&#39; , &#39;graph_category BEAM&#39; , &#39;graph_vlabel processes&#39; , &#39;processes.label processes&#39; ] end def values do [ &#39;processes.value \#{ length ( :erlang . processes ( ) ) } &#39; ] end end The Crow.Plugin behaviour contains in-depth documentation of how to write your plugins. A full reference of plugin output can be found in the Plugin reference document. Additionally, example plugins can be found in the crow_plugins repository.","ref":"introduction.html#writing-plugins","title":"Crow - Writing plugins","type":"extras"},{"doc":"The following keys can be set under the :crow application key to configure crow: :plugins - A list of modules implementing the Crow.Plugin behaviour which are listed to peers. This value can be changed at runtime and workers will pick up the change right away. For example, if you have crow_plugins installed and want the node to provide information about the BEAM, you could set the following: # config/config.exs config :crow , plugins : [ CrowPlugins.BEAM.Memory , CrowPlugins.BEAM.SystemInfo ] :ip - The IP address to listen on. This is passed as the {:ip, ip} option to :gen_tcp.listen/2 . By default, the node will listen on all network interfaces. For example, to only listen on localhost, you could use {127, 0, 0, 1} . This parameter can only be set at application start. :port - The port to listen on. The default of 4949 matches the munin default, but you can change this as you like. This parameter can only be set at application start.","ref":"introduction.html#configuration-options","title":"Crow - Configuration options","type":"extras"}]